//*****************************************************************************************************
//  1. t@C
//		ExcelLib.cpp
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CExcelLib,CWorksheet,CExcelData NX̃Cve[V
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "stdafx.h"
#include "ExcelLib.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

using namespace Excel;

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::CExcelLib
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CExcelLibNXRXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		oϐ̏sB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.01.31 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
CExcelLib::CExcelLib()
{
	m_pExcel = NULL;
	m_pBooks = NULL;
	m_pBook = NULL;
	m_pSheets = NULL;
	m_nErrorCode = 0;
}

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::~CExcelLib
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CExcelLibNXfXgN^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		gpĂIuWFNgB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.01.31 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
CExcelLib::~CExcelLib()
{
	Close();
}

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::Open
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GNZt@CI[v
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		LPCTSTR		pFileName		[I] GNZt@C
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:CFALSE:G[
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		w肳ꂽGNZt@CI[vB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.01.31 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CExcelLib::Open(LPCTSTR pFileName)
{
	if (!Initialize())
		return FALSE;

	TCHAR szFullPath[MAX_PATH];
	if (_fullpath(szFullPath, pFileName, sizeof(szFullPath)) != NULL)
		pFileName = szFullPath;

	try {
		m_pBook = m_pBooks->Open(pFileName);
		m_pSheets = m_pBook->GetWorksheets();
	} catch (_com_error &e) {
		ErrorProc(e);
		return FALSE;
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::New
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GNZt@CVK쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:CFALSE:G[
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		GNZt@CVK쐬B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CExcelLib::New()
{
	if (!Initialize())
		return FALSE;

	try {
		m_pBook = m_pBooks->Add();
		m_pSheets = m_pBook->GetWorksheets();
	} catch (_com_error &e) {
		ErrorProc(e);
		return FALSE;
	}

	return TRUE;
}

BOOL CExcelLib::Exec(CStringArray &aPathName)
{
	if (!Initialize())
		return FALSE;

	try {
		CString sCaptionOrg = (LPCTSTR)m_pExcel->Caption;
		CString sCaptionTmp;
		sCaptionTmp.Format("%d", ::GetTickCount());
		m_pExcel->Caption = (LPCTSTR)sCaptionTmp;

		HWND hWnd;
		hWnd = ::FindWindow("XLMain", sCaptionTmp);
		if(NULL == hWnd)
			return FALSE;

		m_pExcel->Caption = (LPCTSTR)sCaptionOrg;

		int nSize = aPathName.GetSize();
		for (int i= 0; i < nSize; i++)
			m_pBooks->Open((LPCTSTR)aPathName[i]);

		m_pExcel->Visible = true;
		m_pExcel->DisplayAlerts = true;
		Close(FALSE);

		DWORD pid;  // Variable to hold the process ID.
		if (GetWindowThreadProcessId(hWnd, &pid) == 0)
			return FALSE;

		HANDLE hProcess;
		hProcess = OpenProcess(SYNCHRONIZE | PROCESS_ALL_ACCESS, TRUE, pid);
		if (hProcess == NULL)
			return FALSE;

		WaitForSingleObject(hProcess, INFINITE);

		CloseHandle(hProcess);

		return TRUE;
	} catch (...) {
		return FALSE;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::Initialize
//----------------------------------------------------------------------------------------------------
//  2. @\
//		
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		BOOL		TRUE:CFALSE:G[
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		eIuWFNg𐶐B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.01.31 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CExcelLib::Initialize()
{
	Close();

	try {
		m_pExcel.CreateInstance("Excel.Application");
		m_pBooks = m_pExcel->GetWorkbooks();
		m_pExcel->PutSheetsInNewWorkbook(1);
		m_pExcel->DisplayAlerts = false;
	} catch (_com_error &e) {
		ErrorProc(e);
		return FALSE;
	}

	return TRUE;
}

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::ReleaseAll
//----------------------------------------------------------------------------------------------------
//  2. @\
//		IuWFNg
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		eIuWFNgB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.01.31 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelLib::Close(BOOL bQuit)
{
	if (m_pSheets != NULL) {
		m_pSheets.Release();
		m_pSheets = NULL;
	}

	if (m_pBook != NULL) {
		m_pBook.Release();
		m_pBook = NULL;
	}

	if (m_pBooks != NULL) {
		m_pBooks.Release();
		m_pBooks = NULL;
	}

	if (m_pExcel != NULL) {
		if (bQuit) {
			try {
				m_pExcel->Quit();
			} catch (...) {
			}
		}
		m_pExcel.Release();
		m_pExcel = NULL;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelLib::ErrorProc
//----------------------------------------------------------------------------------------------------
//  2. @\
//		G[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		_com_error		&e		[I] COMOIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		COMOIuWFNgG[R[hAG[bZ[WoAۑB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.01.31 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelLib::ErrorProc(_com_error &e)
{
	m_nErrorCode = e.WCode();
	m_sErrorMsg = (LPCTSTR)e.Description();
}

CExcelData::CExcelData()
{
	AddSheet("Sheet1");
	m_nCurrentSheetNo = 0;
}

void CExcelData::AddSheet(LPCTSTR pSheetName)
{
	SSheet *pSheet = m_aSheet.AddElement(pSheetName);

	pSheet->sSheetName = pSheetName;
	pSheet->nUsedCols = 0;
	pSheet->nUsedRows = 0;
	pSheet->nAllocRows = 0;
// Modify ... ( ADD )
	pSheet->bDeleteFlag = false;
// By Y.itabashi (xxxxx) 2007.02.19
}

// Modify ... ( ADD )
void CExcelData::SetDeleteSheet(LPCTSTR pSheetName)
{
	SSheet *pSheet = m_aSheet.LookupElement(pSheetName);

	pSheet->bDeleteFlag = true;
}
// By Y.itabashi (xxxxx) 2007.02.19

//*****************************************************************************************************
//  1. ֐
//		CExcelData::Create
//----------------------------------------------------------------------------------------------------
//  2. @\
//		f[^zVK쐬
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nRows		[I] s
//		int			nCols		[I] 
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^zw肳ꂽTCYŊmۂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::Create(int nRows, int nCols)
{
	SSheet *pSheet = &m_aSheet[m_nCurrentSheetNo];

	SAFEARRAYBOUND sb[2] = {{nRows, 1}, {nCols, 1}};
	pSheet->cSafeArray.Create(VT_VARIANT, 2, sb);

	pSheet->nUsedRows = nRows;
	pSheet->nUsedCols = nCols;
	pSheet->nAllocRows = nRows;
// Modify ... ( ADD )
	pSheet->bDeleteFlag = false;
// By Y.Itabshi (xxxxx) 2007.02.19
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::Read
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GNZt@Cǂݍ
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CExcelLib		&cExcel		[I] CExcelLibIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		GNZt@Cf[^zփf[^ǂݍށB
//----------------------------------------------------------------------------------------------------
//  6. l
//		gp̍sA͏OB
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CExcelData::Read(CExcelLib &cExcel, int nFirstSheet, int nMaxSheet)
{
	try {
		Excel::WorksheetsPtr pWorksheets = cExcel.GetWorksheets();

		int nIndex;
		CString sSheetName;

		m_aSheet.RemoveAll();

		int nSheet = pWorksheets->Count;
		if (nMaxSheet != 0 && nSheet > nMaxSheet)
			nSheet = nMaxSheet;
		for (int i = nFirstSheet; i <= nSheet; i++) {
			Excel::_WorksheetPtr pWorksheet = pWorksheets->Item[(long)i];
			if (pWorksheet->Visible) {
				sSheetName = (LPCTSTR)pWorksheet->GetName();
				SSheet *pSheet = m_aSheet.AddElement(sSheetName, nIndex);
				pSheet->sSheetName = sSheetName;
				m_nCurrentSheetNo = nIndex;
				ReadSub(pWorksheet, pSheet);
// Modify ... ( ADD )
				pSheet->bDeleteFlag = false;
// By Y.itabashi (xxxxx) 2007.02.19
			}
		}
		
		m_nCurrentSheetNo = 0;

		return TRUE;
	} catch (...) {
		return FALSE;
	}
}

void CExcelData::ReadSub(Excel::_WorksheetPtr pWorksheet, SSheet *pSheet)
{
	Excel::RangePtr pRange;
	CString sData;

	Excel::RangePtr pUsedRange = pWorksheet->UsedRange;
	pRange = pUsedRange->Rows->Item[pUsedRange->Rows->Count];
	pSheet->nUsedRows = pRange->Row;
	pRange = pUsedRange->Columns->Item[pUsedRange->Columns->Count];
	pSheet->nUsedCols = pRange->Column;
	pSheet->nAllocRows = pSheet->nUsedRows;

	_variant_t pCell1 = pWorksheet->Cells->GetItem((long)1, (long)1);
	_variant_t pCell2 = pWorksheet->Cells->GetItem((long)pSheet->nUsedRows, (long)pSheet->nUsedCols);
	pRange = pWorksheet->GetRange(pCell1, pCell2);
	if (pSheet->nUsedRows == 1 && pSheet->nUsedCols == 1) {
		Create(1, 1);
		PutElement(1, 1, pRange->Value2);
	} else
		pSheet->cSafeArray.Attach(pRange->Value2);

	// gp̍sO
	while (pSheet->nUsedRows > 0) {
		for (int nCol = 1; nCol <= pSheet->nUsedCols; nCol++) {
			GetElement(pSheet->nUsedRows, nCol, sData);
			if (!sData.IsEmpty())
				break;
		}
		if (nCol <= pSheet->nUsedCols)
			break;

		pSheet->nUsedRows--;
	}

	// gp̗O
	while (pSheet->nUsedCols > 0) {
		for (int nRow = 1; nRow <= pSheet->nUsedRows; nRow++) {
			GetElement(nRow, pSheet->nUsedCols, sData);
			if (!sData.IsEmpty())
				break;
		}
		if (nRow <= pSheet->nUsedRows)
			break;

		pSheet->nUsedCols--;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::Write
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GNZt@C
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CExcelLib		&cExcel		[I] CExcelLibIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z񂩂GNZt@Cփf[^ށB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
BOOL CExcelData::Write(CExcelLib &cExcel, LPCTSTR pPathName)
{
	try {
		Excel::WorksheetsPtr pWorksheets = cExcel.GetWorksheets();

		int nSheet = m_aSheet.GetSize();
// Modify ... ( ADD )
		int nExcelSheet = pWorksheets->Count;

		for( int icnt = nExcelSheet; icnt < nSheet; icnt++ ){
			pWorksheets->Add();
		}
// By Y.Itabashi (xxxxx) 2007.02.14

		for (int i = 0; i < nSheet; i++) {
			Excel::_WorksheetPtr pWorksheet = pWorksheets->Item[(long)(i + 1)];
			WriteSub(pWorksheet, &m_aSheet[i]);
		}

		CString sFullName = (LPCTSTR)cExcel.GetWorkbook()->GetFullName();
		if (pPathName == NULL || sFullName == pPathName)
			cExcel.GetWorkbook()->Save();
		else {
			TCHAR szFullPath[MAX_PATH];
			_fullpath(szFullPath, pPathName, sizeof(szFullPath));
			cExcel.GetWorkbook()->SaveAs(szFullPath, vtMissing, vtMissing, vtMissing, vtMissing, vtMissing, xlNoChange);
		}

		return TRUE;
	} catch (...) {
		return FALSE;
	}
}

void CExcelData::WriteSub(Excel::_WorksheetPtr pWorksheet, SSheet *pSheet)
{
	// tB^̏
	if (pWorksheet->GetFilterMode())
		pWorksheet->ShowAllData();

	if (pSheet->nUsedRows != 0 && pSheet->nUsedCols != 0) {
		_variant_t pCell1 = pWorksheet->Cells->GetItem((long)1, (long)1);
		_variant_t pCell2 = pWorksheet->Cells->GetItem((long)pSheet->nUsedRows, (long)pSheet->nUsedCols);
		_variant_t vEmpty;
		pWorksheet->Cells->Value = vEmpty;
		Excel::RangePtr pRange = pWorksheet->GetRange(pCell1, pCell2);
		pRange->Value2 = pSheet->cSafeArray;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::Copy
//----------------------------------------------------------------------------------------------------
//  2. @\
//		zf[^Rs[
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CExcelData		&cSrc		[I] CExcelDataIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		ʂ̃f[^z񂩂Sf[^Rs[B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::Copy(CExcelData &cSrc)
{
	SSheet *pSheet = &m_aSheet[m_nCurrentSheetNo];

	pSheet->cSafeArray.Clear();
	pSheet->cSafeArray.Attach(cSrc.GetSafeArray().Detach());

	pSheet->nUsedRows = cSrc.GetUsedRows();
	pSheet->nUsedCols = cSrc.GetUsedCols();
	pSheet->nAllocRows = cSrc.GetAllocRows();
// modify ... ( ADD )
	pSheet->bDeleteFlag = false;
// By Y.Itabashi (xxxxx) 2007.02.19
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::SetSheetName
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GNZt@C̃V[gύX
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CExcelLib		&cExcel		[I] CExcelLibIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z̃V[gGNZt@Cփf[^ށB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2007.02.15 Y.Itabashi(xxxxx) VK쐬
//*****************************************************************************************************
BOOL CExcelData::SetSheetName(CExcelLib &cExcel, LPCTSTR pPathName)
{
	try {
		Excel::WorksheetsPtr pWorksheets = cExcel.GetWorksheets();

		int nSheet = m_aSheet.GetSize();
		for (int i = 0; i < nSheet; i++) {
			Excel::_WorksheetPtr pWorksheet = pWorksheets->Item[(long)(i + 1)];

			// sheet ݒ
			_bstr_t _sheet_name (m_aSheet[i].sSheetName);
			pWorksheet->PutName (_sheet_name);
		}

		CString sFullName = (LPCTSTR)cExcel.GetWorkbook()->GetFullName();
		if (pPathName == NULL || sFullName == pPathName)
			cExcel.GetWorkbook()->Save();
		else {
			TCHAR szFullPath[MAX_PATH];
			_fullpath(szFullPath, pPathName, sizeof(szFullPath));
			cExcel.GetWorkbook()->SaveAs(szFullPath, vtMissing, vtMissing, vtMissing, vtMissing, vtMissing, xlNoChange);
		}

		return TRUE;
	} catch (...) {
		return FALSE;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::DeleteSheet
//----------------------------------------------------------------------------------------------------
//  2. @\
//		GNZt@C̎wV[g폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		CExcelLib		&cExcel		[I] CExcelLibIuWFNg
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z̃V[gGNZt@Cփf[^ށB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2007.02.15 Y.Itabashi(xxxxx) VK쐬
//*****************************************************************************************************
BOOL CExcelData::DeleteSheet(CExcelLib &cExcel, LPCTSTR pPathName)
{
	try {
		Excel::WorksheetsPtr pWorksheets = cExcel.GetWorksheets();

		int nSheet = m_aSheet.GetSize();
		for( int icnt = nSheet-1; icnt >= 0; icnt-- ){
			if( m_aSheet[icnt].bDeleteFlag ){
				Excel::_WorksheetPtr pWorksheet = pWorksheets->Item[(long)(icnt + 1)];
				pWorksheet->Delete();
			}
		}


		CString sFullName = (LPCTSTR)cExcel.GetWorkbook()->GetFullName();
		if (pPathName == NULL || sFullName == pPathName)
			cExcel.GetWorkbook()->Save();
		else {
			TCHAR szFullPath[MAX_PATH];
			_fullpath(szFullPath, pPathName, sizeof(szFullPath));
			cExcel.GetWorkbook()->SaveAs(szFullPath, vtMissing, vtMissing, vtMissing, vtMissing, vtMissing, xlNoChange);
		}

		return TRUE;
	} catch (...) {
		return FALSE;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::Clear
//----------------------------------------------------------------------------------------------------
//  2. @\
//		zf[^폜
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z̗vf0ɂB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::Clear()
{
	SSheet *pSheet = &m_aSheet[m_nCurrentSheetNo];

	pSheet->cSafeArray.Destroy();

	pSheet->nUsedRows = 0;
	pSheet->nUsedCols = 0;
	pSheet->nAllocRows = 0;
// Modify ... ( ADD )
	pSheet->bDeleteFlag = false;
// By Y.Itabashi (xxxxx) 2007.02.19
}

void CExcelData::SetCols(int nCols)
{
	SSheet *pSheet = &m_aSheet[m_nCurrentSheetNo];

	if (nCols > pSheet->nUsedCols) {
		SAFEARRAYBOUND sb[1] = {{nCols, 1}};
		pSheet->cSafeArray.Redim(sb);
	}

	pSheet->nUsedCols = nCols;
}

void CExcelData::SetRows(int nRows)
{
	SSheet *pSheet = &m_aSheet[m_nCurrentSheetNo];

	if (nRows > pSheet->nAllocRows)
		AddRows(nRows - pSheet->nAllocRows);
	else
		pSheet->nUsedRows = nRows;
}

int CExcelData::AddRows(int nAddRows)
{
	SSheet *pSheet = &m_aSheet[m_nCurrentSheetNo];
	int nNewRows = pSheet->nUsedRows + nAddRows;
	if (nNewRows > pSheet->nAllocRows) {
		CExcelData cTempData;
		variant_t vData;

		// XɍsǉꍇɔĂPmۂ
		cTempData.Create(nNewRows + nNewRows / 10, pSheet->nUsedCols);

		int nUsedRows = pSheet->nUsedRows;
		for (int nRow = 1; nRow <= nUsedRows; nRow++) {
			for (int nCol = 1; nCol <= pSheet->nUsedCols; nCol++) {
				GetElement(nRow, nCol, vData);
				cTempData.PutElement(nRow, nCol, vData);
			}
		}

		Copy(cTempData);
	}

	pSheet->nUsedRows = nNewRows;

	return nNewRows;
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::GetElement
//----------------------------------------------------------------------------------------------------
//  2. @\
//		Variant^f[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nRow		[I] sʒu
//		int			nCol		[I] ʒu
//		_variant_t	&vData		[I] 擾f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z񂩂w肳ꂽʒũf[^Variant^Ŏ擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::GetElement(int nRow, int nCol, _variant_t &vData)
{
	long nIndex[2] = {nRow, nCol};

	m_aSheet[m_nCurrentSheetNo].cSafeArray.GetElement(nIndex, &vData);
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::GetElement
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^f[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nRow		[I] sʒu
//		int			nCol		[I] ʒu
//		CString		&sData		[I] 擾f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z񂩂w肳ꂽʒũf[^𕶎^Ŏ擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::GetElement(int nRow, int nCol, CString &sData)
{
	try {
		_variant_t vData;

		GetElement(nRow, nCol, vData);
		vData.ChangeType(VT_BSTR);
		sData = V_BSTR(&vData);
		sData.TrimLeft();
		sData.TrimRight();
	} catch (...) {
		sData.Empty();
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::GetElement
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^f[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nRow		[I] sʒu
//		int			nCol		[I] ʒu
//		double		&dData		[I] 擾f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z񂩂w肳ꂽʒũf[^𕂓^Ŏ擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::GetElement(int nRow, int nCol, double &dData)
{
	try {
		_variant_t vData;

		GetElement(nRow, nCol, vData);
		vData.ChangeType(VT_R8);
		dData = V_R8(&vData);
	} catch (...) {
		dData = 0;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::GetElement
//----------------------------------------------------------------------------------------------------
//  2. @\
//		^f[^擾
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nRow		[I] sʒu
//		int			nCol		[I] ʒu
//		int			&nData		[I] 擾f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z񂩂w肳ꂽʒũf[^𐮐^Ŏ擾B
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::GetElement(int nRow, int nCol, int &nData)
{
	try {
		_variant_t vData;

		GetElement(nRow, nCol, vData);
		vData.ChangeType(VT_I4);
		nData = V_I4(&vData);
	} catch (...) {
		nData = 0;
	}
}

//*****************************************************************************************************
//  1. ֐
//		CExcelData::GetElement
//----------------------------------------------------------------------------------------------------
//  2. @\
//		f[^
//----------------------------------------------------------------------------------------------------
//  3. p[^
//		int			nRow		[I] sʒu
//		int			nCol		[I] ʒu
//		_variant_t	vData		[I] ݃f[^
//----------------------------------------------------------------------------------------------------
//  4. ߂l
//		
//----------------------------------------------------------------------------------------------------
//  5. Tv
//		f[^z̎w肳ꂽʒuɃf[^ށB
//----------------------------------------------------------------------------------------------------
//  6. l
//----------------------------------------------------------------------------------------------------
//  7. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************
void CExcelData::PutElement(int nRow, int nCol, _variant_t &vData)
{
	long nIndex[2] = {nRow, nCol};

	m_aSheet[m_nCurrentSheetNo].cSafeArray.PutElement(nIndex, &vData);
}
